/*
 * Copyright 2009 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package bufferings.ktr.i18n.test.server.service;

import bufferings.ktr.i18n.client.KtrI18NException;
import bufferings.ktr.i18n.test.client.QualifiedNameSample;
import bufferings.ktr.i18n.test.client.SampleDTO;
import bufferings.ktr.i18n.test.client.SimpleNameSample;
import bufferings.ktr.i18n.test.client.StaticImportOnDemandSample;
import bufferings.ktr.i18n.test.client.StaticImportSample;
import bufferings.ktr.i18n.test.client.service.KtrI18NTestService;

/**
 * The server side implementation of the RPC service.
 *
 * @author bufferings[at]gmail.com
 */
public class KtrI18NTestServiceImpl implements KtrI18NTestService {

  /** {@inheritDoc} */
  @Override
  public SampleDTO getSampleDTO() throws KtrI18NException {

    SimpleNameSample simpleNameSample = new SimpleNameSample();
    QualifiedNameSample qualifiedNameSample = new QualifiedNameSample();
    StaticImportSample staticImportSample = new StaticImportSample();
    StaticImportOnDemandSample staticImportOnDemandSample =
      new StaticImportOnDemandSample();

    SampleDTO dto = new SampleDTO();
    dto.simpleNameConst = simpleNameSample.getMyConstants().SAMPLE_CONST_NAME();
    dto.simpleNameConstEn =
      simpleNameSample.getMyConstantsWithLocale("en", "").SAMPLE_CONST_NAME();
    dto.simpleNameMsg = simpleNameSample.getMyMessages().welcome("Server");
    dto.simpleNameMsgJa =
      simpleNameSample.getMyMessagesWithLocaleJa().welcome("Server");

    dto.qualifiedNameConst =
      qualifiedNameSample.getMyConstants().SAMPLE_CONST_NAME();
    dto.qualifiedNameConstEn =
      qualifiedNameSample
        .getMyConstantsWithLocale("en", "")
        .SAMPLE_CONST_NAME();
    dto.qualifiedNameMsg =
      qualifiedNameSample.getMyMessages().welcome("Server");
    dto.qualifiedNameMsgJa =
      qualifiedNameSample.getMyMessagesWithLocaleJa().welcome("Server");

    dto.staticImportConst =
      staticImportSample.getMyConstants().SAMPLE_CONST_NAME();
    dto.staticImportConstEn =
      staticImportSample.getMyConstantsWithLocale("en", "").SAMPLE_CONST_NAME();
    dto.staticImportMsg = staticImportSample.getMyMessages().welcome("Server");
    dto.staticImportMsgJa =
      staticImportSample.getMyMessagesWithLocaleJa().welcome("Server");

    dto.staticImportOnDemandConst =
      staticImportOnDemandSample.getMyConstants().SAMPLE_CONST_NAME();
    dto.staticImportOnDemandConstEn =
      staticImportOnDemandSample
        .getMyConstantsWithLocale("en", "")
        .SAMPLE_CONST_NAME();
    dto.staticImportOnDemandMsg =
      staticImportOnDemandSample.getMyMessages().welcome("Server");
    dto.staticImportOnDemandMsgJa =
      staticImportOnDemandSample.getMyMessagesWithLocaleJa().welcome("Server");

    return dto;
  }

}
